
//-----------------------------------------------------
//导入
//________________________________________________________________

import { world, system } from '@minecraft/server';
import { score } from 'score.js';

//-----------------------------------------------------
//函数
//________________________________________________________________

//懒得写了自己看
export function attack(player, entity, amount, strength, distance) {
    try {
        if (player.hasTag("be_stopped_of_time"))return;
        if (entity.hasComponent("minecraft:health")) {
        
            //计算药水效果加成
            let str;
            let wk;
            try {
                 str = player.getEffect("strength").amplifier;
            } catch (e) {
                 str = -1;
            }
            try {
                 wk = player.getEffect("weakness").amplifier;
            } catch (e) {
                 wk = -1;
            }
            str = str - wk -1;
            
            //特效
            if (distance >= 0) {
                if (  score(player, "stand_type_id") > 0 && score(player, "stand_type_id") < 5 && 0 < score(player, "stand_skill_cd_2") && score(player, "stand_skill_cd_2") < 10 
                   || score(player, "stand_type_id") == 6 && 0 < score(player, "stand_skill_cd_2") && score(player, "stand_skill_cd_2") < 10
                   || score(player, "stand_type_id") == 9 && 0 < score(player, "stand_skill_cd_3") && score(player, "stand_skill_cd_3") < 10
                   ) {
                    player.runCommand(`particle stand:sweep ^${randomNum(-0.5, 0.5)}^${randomNum(1, 1.25)}^${distance - 0.5}`)
                    entity.runCommand("tp ~~1.5~ true")
                } else {
                    if (amount != 0) {
                        player.runCommand(`particle stand:beat ^${randomNum(-0.5, 0.5)}^${randomNum(1, 1.25)}^${distance - 0.5}`)
                    }
                }
            }
            
            //计算加成后最终伤害
            let reallyDamage = (amount+((str +1)*2.5)) > 0 ? (amount+((str +1)*2.5)) : 0
            if (player.hasTag("jojo3")) {
                reallyDamage = reallyDamage * 1.25
            }
            if (score(player, "life_level") > 0) {
                reallyDamage = reallyDamage*(score(player, "life_level")/20 + 1)
            }
            
            entity.applyDamage(reallyDamage, {
                cause: "entityAttack",
                damagingEntity: player
            })
            
            player.runCommand(`camerashake add @a[r=${parseInt(amount/3)}] ${amount/40 + score(player, "pl.co")/20} 0.1`)
            
            //暴击
            player.runCommand("tag @s remove crit")
            player.runCommand("execute as @s anchored feet if block ~~-0.25~ air run tag @s add crit")
            if (player.hasTag("crit")) {
                entity.applyDamage(reallyDamage, {
                    cause: "ramAttack",
                    damagingEntity: player
                })
                entity.runCommand("particle minecraft:critical_hit_emitter ~ ~1 ~")
            }
        };
    } catch (e) {
        // world.sendMessage(`${e}`)
    }
    
    if (score(player, "stand_type_id") > 0 && randomNum(0, 9) == 1) {
        player.runCommand("scoreboard players add @s[scores={stand_level=..99}] stand_level 1")
    }
    if (strength != 5.010203) {
       player.runCommand("playsound mob.ravager.step @a ~~~ 100000 2 10000")
    } else {
       player.runCommand("playsound sword_hit @a ~~~ 80 2 0")
    }

    function randomNum(minNum, maxNum) {
       switch (arguments.length) {
            case 1:
                return parseInt(Math.random() * minNum + 1, 10);
                break;
            case 2:
                return parseInt(Math.random() * (maxNum - minNum + 1) + minNum, 10);
                break;
            default:
                return 0;
                break;
       }
    };
    
    function extendLineSegment(A, B, x) {
        // 计算线段 AB 的方向向量
        const directionVector = {
            x: B.x - A.x,
            y: B.y - A.y,
            z: B.z - A.z,
        };

        // 计算点 C 的坐标
        const C = {
            x: (directionVector.x * x) / 100,
            y: (directionVector.y * x) / 100,
            z: (directionVector.z * x) / 100,
        };
        const D = {
            x: (directionVector.x * -1),
            y: (directionVector.y * -1),
            z: (directionVector.z * -1),
        };

        return [C,D];
    }

    const pointC = extendLineSegment(player.location, entity.location, strength)[0];
    if (entity.hasTag("be_stopped_of_time")) {
        if (entity.typeId != "minecraft:player") {
            let scoreboardVelocity = {
                x: parseInt(pointC.x * 1000),
                y: parseInt(pointC.y * 1000),
                z: parseInt(pointC.z * 1000)
            }
            entity.runCommand("scoreboard players add @s stand_time_stop_vx " + scoreboardVelocity.x)
            entity.runCommand("scoreboard players add @s stand_time_stop_vy " + scoreboardVelocity.y)
            entity.runCommand("scoreboard players add @s stand_time_stop_vz " + scoreboardVelocity.z)
        }
    } else {
        if (entity.typeId != "minecraft:player") {
            entity.applyImpulse(pointC)
        } else {
            player.runCommand(`damage @a[name="${entity.name}"] 0 magic entity @s`)
            if (strength == 149.9) {
                entity.runCommand(`tp ~~~ facing @p[name=${player.name}]`)
                entity.runCommand("tp ^^1^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
                entity.runCommand("tp ^^^-1 true")
           }
        }
    }
}

export function idAttack(playerId, entityId, amount, strength, distance) {
    try {
        const player = world.getEntity(playerId)
        const entity = world.getEntity(entityId)
        attack(player, entity, amount, strength, distance)
    } catch(e) {
        world.sendMessage(`${e}`)
    }
}

export function projectile(player, entity, amount, strength, distance) {
    try {
        if (entity.hasComponent("minecraft:health")) {
            entity.runCommand(`damage @s ${parseInt(amount)} projectile entity @e[tag=id${player.id}]`)
        }
    } catch (e) {
        // world.sendMessage(`${e}`)
    }

    function extendLineSegment(A, B, x) {
        // 计算线段 AB 的方向向量
        const directionVector = {
            x: B.x - A.x,
            y: B.y - A.y,
            z: B.z - A.z,
        };

        // 计算点 C 的坐标
        const C = {
            x: (directionVector.x * x) / 100,
            y: (directionVector.y * x) / 100,
            z: (directionVector.z * x) / 100,
        };
        const D = {
            x: (directionVector.x * -1),
            y: (directionVector.y * -1),
            z: (directionVector.z * -1),
        };
        return [C,D];
    }

    const pointC = extendLineSegment(player.location, entity.location, strength)[0];
    if (entity.hasTag("be_stopped_of_time")) {
        if (entity.typeId != "minecraft:player") {
            let scoreboardVelocity = {
                x: parseInt(pointC.x * 1000),
                y: parseInt(pointC.y * 1000),
                z: parseInt(pointC.z * 1000)
            }
            entity.runCommand("scoreboard players add @s stand_time_stop_vx " + scoreboardVelocity.x)
            entity.runCommand("scoreboard players add @s stand_time_stop_vy " + scoreboardVelocity.y)
            entity.runCommand("scoreboard players add @s stand_time_stop_vz " + scoreboardVelocity.z)
        }
    } else {
        if (entity.typeId != "minecraft:player") {
            entity.applyImpulse(pointC)
        } else {
            player.runCommand(`damage @a[name="${entity.name}"] 0 magic entity @s`)
        }
    }
}


// 获取玩家视觉射线上的第一个障碍物
function getFirstObstacle(player, maxDistance) {
    const playerLocation = player.getHeadLocation();
    const viewDirection = player.getViewDirection();

    // 获取视觉射线上的第一个方块
    const blockHit = player.dimension.getBlockFromRay(playerLocation, viewDirection, {
        maxDistance: maxDistance,
    });

    if (blockHit) {
        // world.sendMessage(`${blockHit.block.typeId}:${blockHit.block.location.x}`)
        return blockHit.block.location;
    } else {
        return undefined;
    }
}

// 获取圆柱体内的实体，但不能穿墙瞄准
export function getEntites(player, distance) {
    const radius = 0.5
    const playerLocation = player.getHeadLocation();
    const viewDirection = player.getViewDirection();

    // 获取视觉射线上的第一个障碍物
    const obstacleLocation = getFirstObstacle(player, distance);
    const points = [obstacleLocation, playerLocation];
    function distanceTo(points) {
        var p1 = points[0];
        var p2 = points[1];
        var a = p2.x - p1.x;
        var b = p2.z - p1.z;
        var c = p2.y - p1.y;
        return Math.sqrt(a * a + b * b + c * c);
    };
    const maxDistance = obstacleLocation ? distanceTo(points) : distance;

    // 获取玩家所在维度的所有实体
    const allEntities = player.dimension.getEntities({
        location: playerLocation,
        maxDistance: maxDistance,
    });

    // 筛选出在圆柱体内的实体
    const entitiesInCylinder = allEntities.filter(entity => {
        if (entity.id != player.id) {
            const el = entity.getHeadLocation();
            const el2 = entity.location
            const entityLocation = {
                x: el2.x,
                y: (el.y + el2.y)/2,
                z: el2.z
            }
            const vectorToEntity = {
                x: entityLocation.x - playerLocation.x,
                y: entityLocation.y - playerLocation.y,
                z: entityLocation.z - playerLocation.z,
            };
    
            // 计算实体到射线的投影距离
            const distanceAlongRay = (
                vectorToEntity.x * viewDirection.x +
                vectorToEntity.y * viewDirection.y +
                vectorToEntity.z * viewDirection.z
            );
    
            // 计算实体到射线的垂直距离
            const closestPointOnRay = {
                x: playerLocation.x + viewDirection.x * distanceAlongRay,
                y: playerLocation.y + viewDirection.y * distanceAlongRay,
                z: playerLocation.z + viewDirection.z * distanceAlongRay,
            };
    
            const distanceFromRay = Math.sqrt(
                Math.pow(entityLocation.x - closestPointOnRay.x, 2) +
                Math.pow(entityLocation.y - closestPointOnRay.y, 2) +
                Math.pow(entityLocation.z - closestPointOnRay.z, 2)
            );
    
            // 检查实体是否在圆柱体内
            return distanceFromRay <= (radius + (el.y - (el.y + el2.y)/2)) && distanceAlongRay >= 0 && distanceAlongRay <= maxDistance;
        }
    });
    
    let newE = []
    for (const entity of entitiesInCylinder) {
        const el = {
            entity: entity
        }
        newE.push(el)
    }
    
    return newE;
}

// export function getEntites(player, distance) {
    // try {
        // let arr = player.dimension.getEntitiesFromRay(
            // player.getHeadLocation(),
            // player.getViewDirection(),
            // {
                // maxDistance: distance
            // }
        // )
        // const location2 = { 
            // x: player.getHeadLocation().x,
            // y: player.getHeadLocation().y + 0.25,
            // z: player.getHeadLocation().z
        // }
        // let arr2 = player.dimension.getEntitiesFromRay(
            // location2,
            // player.getViewDirection(),
            // {
                // maxDistance: distance
            // }
        // )
        // const location3 = { 
            // x: player.getHeadLocation().x,
            // y: player.getHeadLocation().y - 0.25,
            // z: player.getHeadLocation().z
        // }
        // let arr3 = player.dimension.getEntitiesFromRay(
            // location3,
            // player.getViewDirection(),
            // {
                // maxDistance: distance
            // }
        // )
        // const location4 = { 
            // x: player.getHeadLocation().x - 0.25,
            // y: player.getHeadLocation().y,
            // z: player.getHeadLocation().z
        // }
        // let arr4 = player.dimension.getEntitiesFromRay(
            // location4,
            // player.getViewDirection(),
            // {
                // maxDistance: distance
            // }
        // )
        // const location5 = { 
            // x: player.getHeadLocation().x + 0.25,
            // y: player.getHeadLocation().y,
            // z: player.getHeadLocation().z
        // }
        // let arr5 = player.dimension.getEntitiesFromRay(
            // location5,
            // player.getViewDirection(),
            // {
                // maxDistance: distance
            // }
        // )
        // const location6 = { 
            // x: player.getHeadLocation().x,
            // y: player.getHeadLocation().y,
            // z: (player.getHeadLocation().z - 0.25)
        // }
        // let arr6 = player.dimension.getEntitiesFromRay(
            // location6,
            // player.getViewDirection(),
            // {
                // maxDistance: distance
            // }
        // )
        // const location7 = { 
            // x: player.getHeadLocation().x,
            // y: player.getHeadLocation().y,
            // z: (player.getHeadLocation().z + 0.25)
        // }
        // let arr7 = player.dimension.getEntitiesFromRay(
            // location7,
            // player.getViewDirection(),
            // {
                // maxDistance: distance
            // }
        // )
        // let entities = [];
        // let ids = [];
        // for (const entity of arr) {
            // if (entity.entity.id != player.id && ids.indexOf(entity.entity.id) == -1) {
                // let date = {
                    // id: entity.entity.id,
                    // distance: entity.distance
                // }
                // entities.push(date)
                // ids.push(entity.entity.id)
            // }
        // }
        // for (const entity of arr2) {
            // if (entity.entity.id != player.id && ids.indexOf(entity.entity.id) == -1) {
                // let date = {
                    // id: entity.entity.id,
                    // distance: entity.distance
                // }
                // entities.push(date)
                // ids.push(entity.entity.id)
            // }
        // }
        // for (const entity of arr3) {
            // if (entity.entity.id != player.id && ids.indexOf(entity.entity.id) == -1) {
                // let date = {
                    // id: entity.entity.id,
                    // distance: entity.distance
                // }
                // entities.push(date)
                // ids.push(entity.entity.id)
            // }
        // }
        // for (const entity of arr4) {
            // if (entity.entity.id != player.id && ids.indexOf(entity.entity.id) == -1) {
                // let date = {
                    // id: entity.entity.id,
                    // distance: entity.distance
                // }
                // entities.push(date)
                // ids.push(entity.entity.id)
            // }
        // }
        // for (const entity of arr5) {
            // if (entity.entity.id != player.id && ids.indexOf(entity.entity.id) == -1) {
                // let date = {
                    // id: entity.entity.id,
                    // distance: entity.distance
                // }
                // entities.push(date)
                // ids.push(entity.entity.id)
            // }
        // }
        // for (const entity of arr6) {
            // if (entity.entity.id != player.id && ids.indexOf(entity.entity.id) == -1) {
                // let date = {
                    // id: entity.entity.id,
                    // distance: entity.distance
                // }
                // entities.push(date)
                // ids.push(entity.entity.id)
            // }
        // }
        // for (const entity of arr7) {
            // if (entity.entity.id != player.id && ids.indexOf(entity.entity.id) == -1) {
                // let date = {
                    // id: entity.entity.id,
                    // distance: entity.distance
                // }
                // entities.push(date)
                // ids.push(entity.entity.id)
            // }
        // }
        // let entities2 = []
        // for (const date of entities) {
            // let entity2 = {}
            // let entity3 = player.dimension.getEntities({
                // tags: [`id${date.id}`],
            // })[0];
            // entity2 = {
                // entity : entity3,
                // distance: date.distance
            // }
            // if (entity3.getComponent("minecraft:health") != 0) {
                // entities2.push(entity2) 
            // }
        // }
        // return entities2;
    // } catch (error) {
        // return []
    // }
// }

export function breakBlock(player, distance) {
    let block;
    if (player.getBlockFromViewDirection({maxDistance:distance}) != undefined) {
        block = player.getBlockFromViewDirection({maxDistance:distance}).block
        if (
            block.typeId.includes("planks")||
            block.typeId.includes("obsidian")||
            block.typeId.includes("fence")||
            block.typeId.includes("diamond")||
            block.typeId.includes("ore")||
            block.typeId.includes("iron")||
            block.typeId.includes("coal")||
            block.typeId.includes("gold")||
            block.typeId.includes("netherite")||
            block.typeId.includes("lapis")||
            block.typeId.includes("emerald")||
            block.typeId.includes("copper")||
            block.typeId.includes("door")||
            block.typeId.includes("bed")||
            block.typeId.includes("stairs") ||
            block.typeId.includes("sign")||
            block.typeId.includes("log")||
            block.typeId.includes("grass")||
            block.typeId.includes("glass")||
            block.typeId.includes("dirt")||
            block.typeId.includes("wall")||
            block.typeId.includes("stone")||
            block.typeId.includes("wood")||
            block.typeId.includes("sand")||
            block.typeId.includes("tuff")||
            block.typeId.includes("basalt")||
            block.typeId.includes("anvil")||
            block.typeId.includes("netherrack")||
            block.typeId.includes("quartz")||
            block.typeId.includes("tnt")||
            block.typeId.includes("met")||
            block.typeId.includes("deepslate")
        ) {
                if (!block.typeId.includes("bedrock")) {
                    if (world.getDynamicProperty("break") == "no")return;
                    player.runCommand(`execute as @s[m=!adventure,tag=destroy] run setblock ${block.x} ${block.y} ${block.z} air destroy`)
                }
           }
    }
}

export function breakGetBlock(player, distance) {
    let block;
    if (player.getBlockFromViewDirection({maxDistance:distance}) != undefined) {
        block = player.getBlockFromViewDirection({maxDistance:distance}).block
        if (!block) {
            return [];
        }
        if (
            block.typeId.includes("planks")||
            block.typeId.includes("obsidian")||
            block.typeId.includes("fence")||
            block.typeId.includes("diamond")||
            block.typeId.includes("ore")||
            block.typeId.includes("iron")||
            block.typeId.includes("coal")||
            block.typeId.includes("gold")||
            block.typeId.includes("netherite")||
            block.typeId.includes("lapis")||
            block.typeId.includes("tnt")||
            block.typeId.includes("emerald")||
            block.typeId.includes("copper")||
            block.typeId.includes("door")||
            block.typeId.includes("bed")||
            block.typeId.includes("chest")||
            block.typeId.includes("stairs") ||
            block.typeId.includes("sign")||
            block.typeId.includes("log")||
            block.typeId.includes("grass")||
            block.typeId.includes("glass")||
            block.typeId.includes("dirt")||
            block.typeId.includes("wall")||
            block.typeId.includes("stone")||
            block.typeId.includes("wood")||
            block.typeId.includes("sand")||
            block.typeId.includes("tuff")||
            block.typeId.includes("basalt")||
            block.typeId.includes("netherrack")||
            block.typeId.includes("anvil")||
            block.typeId.includes("quartz")||
            block.typeId.includes("deepslate")
        ) {
                if (!block.typeId.includes("bedrock")) {
                    player.runCommand("tag @s[m=!adventure] add _adventure")
                    if (player.hasTag("_adventure")) {
                        player.removeTag("_adventure")
                        return [block.typeId, block.x, block.y, block.z, block.dimension.id];
                    }
                }
           }
    }
}