//-----------------------------------------------------
//导入
//________________________________________________________________

import { world, system, ItemStack } from '@minecraft/server';
import { roller } from 'monster/dio'

//-----------------------------------------------------
//事件
//________________________________________________________________

world.afterEvents.itemUse.subscribe(event => {
    const item = event.itemStack;
    const player = event.source;
    if (item.typeId != "stand:roller_spawn_egg" || !player.isOnGround || player.hasTag("be_stopped_of_time")) return;
    player.runCommand("effect @s levitation 2 20 true")
    system.runTimeout(() => {  
        roller(player)
    }, 6)
    system.runTimeout(() => {  
        player.runCommand("effect @s levitation 0 10 true")
        player.runCommand("effect @s slow_falling 5 1 true")
    }, 10)
});