//-----------------------------------------------------
//导入
//________________________________________________________________

import { world } from '@minecraft/server';

//-----------------------------------------------------
//函数
//________________________________________________________________

//最important的function
export function score(player, objective) {
    try {
        return world.scoreboard.getObjective(objective)
            .getScore(player.scoreboardIdentity)
    } catch (e) {
        return 0;
    }
}

export function set(player, scoreboard, number) {
    player.runCommand("scoreboard players set @s " + scoreboard + " " + number)
};

export function add(player, scoreboard, number) {
    player.runCommand("scoreboard players add @s " + scoreboard + " " + number)
};