//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack, world, system } from '@minecraft/server';
import { ActionFormData, ModalFormData } from '@minecraft/server-ui';
import { score, set } from 'score.js';

//-----------------------------------------------------
//事件
//________________________________________________________________

world.afterEvents.itemUse.subscribe(event => {
    const item = event.itemStack;
    const player = event.source;
    if (item.typeId == "minecraft:paper" && score(player, "stand_type_id") == 5) {
        e(player, item)
    }
});
//-----------------------------------------------------
//函数
//________________________________________________________________
function e(player, item) {
    const container = player.getComponent("minecraft:inventory").container;
    if (player.isSneaking) {
        if (score(player, "stand_skill_cd_1") == 0) {
            player.runCommand("scoreboard players set @s stand_skill_cd_1 20")
            if (item.getLore() == "") {
                player.runCommand("scoreboard players add @s eid 1")
                player.runCommand("execute as @s positioned ^^^1 run tag @e[r=2,type=!player,type=!stand:players,type=!stand:anbs_player,c=1,type=!stand:paper,family=!stand_summon] add 捕捉")
                player.runCommand("execute as @s positioned ^^^1 run execute as @e[r=2,type=!player,c=1,tag=捕捉] at @s run particle stand:enigma_sparkler_emitter ~~1~")
                player.runCommand("execute as @s positioned ^^^1 run execute as @e[r=2,type=!player,c=1,tag=捕捉] at @s run tp ~ 320 ~")
                player.runCommand(`execute as @s positioned ~ 320 ~ run execute as @e[r=10,type=!player,c=1,tag=捕捉] at @s run structure save "#§${player.id}${score(player, "eid")}" ~~~ ~~~ true memory false`)
                player.runCommand("execute as @s positioned ~ 320 ~ run execute as @e[r=10,type=!player,c=1,tag=捕捉] at @s run scriptevent stand:eval player.remove()")
                player.runCommand("execute as @s positioned ^^^1 run execute as @e[r=2,type=!player,c=1,tag=捕捉] at @s run playsound mob.endermen.portal @a ~~~ 100 1 0")
                player.runCommand("effect @s slowness 1 1 true")
                player.runCommand("clear @s paper 0 1")
                item.setLore([`#§${player.id}${score(player, "eid")}`])
                item.amount = 1
                item.nameTag = "§r§f奇怪的纸"
                player.dimension.spawnItem(item, player.location)
            } else {
                player.runCommand(`structure load "${item.getLore()}" ^^1^1`)
                player.runCommand("particle stand:enigma_sparkler_emitter ^^1^1")
                player.runCommand("playsound mob.endermen.portal")
                player.runCommand("effect @s slowness 1 1 true")
                item.setLore([])
                item.nameTag = ""
                container.setItem(player.selectedSlotIndex, item)
            }
        }
    } else {
        if (score(player, "stand_skill_cd_1") == 0) {
            player.runCommand("scoreboard players set @s stand_skill_cd_1 200")
            player.runCommand("particle stand:enigma_sparkler_emitter ~~~")
            player.runCommand("playsound mob.endermen.portal")
            player.runCommand("ride @p summon_ride stand:paper skip_riders")
        }
    }
}