//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack, world, system } from '@minecraft/server';
import { ActionFormData, MessageFormData, ModalFormData } from '@minecraft/server-ui';
import { score, set } from 'score.js';
import { attack, projectile, getEntites,  breakBlock } from 'base/attack.js';
import { attacks, entityBoom, } from 'stands/kq.js';

//-----------------------------------------------------
//变量
//________________________________________________________________

let boomId = []
const co = ["a", "b", "c"]

//-----------------------------------------------------
//事件
//________________________________________________________________

world.afterEvents.entityHurt.subscribe(event => {
    try {
        const entity = event.hurtEntity;
        const damagingEntity = event.damageSource.damagingEntity
        if (damagingEntity.typeId != "stand:jj") return;
        damagingEntity.runCommand("scoreboard players add @s mr.co 0")

        let animation = co[score(damagingEntity, "mr.co")]
        damagingEntity.runCommand("playanimation @s animation.stand.kq.m1" + animation)
        if (animation == "a" || animation == "b") {
            attacks(damagingEntity, 10, 10)
            boomId[damagingEntity.id] = entity.id
        } else {
            try {
                entityBoom(world.getEntity(boomId[damagingEntity.id]), damagingEntity)
            } catch (error) {}
        }

        damagingEntity.runCommand("scoreboard players add @s mr.co 1")
        damagingEntity.runCommand("scoreboard players set @s[scores={mr.co=3..}] mr.co 0")
    } catch (error) {}
})