//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack, world, system } from '@minecraft/server';
import { score, set } from 'score.js';
import { attack, projectile,  getEntites, breakBlock } from 'base/attack.js';

//-----------------------------------------------------
//事件
//________________________________________________________________

world.afterEvents.entityHurt.subscribe(event => {
    try {
        const entity = event.hurtEntity;
        const damagingEntity = event.damageSource.damagingEntity
        const cause = event.damageSource.cause;
        if (damagingEntity.typeId != "stand:artist" || cause == "magic") return;
        damagingEntity.runCommand(`effect @e[r=3,type=${entity.typeId}] slowness 5 3`)
    } catch (error) {}
})