//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack, world,  system } from '@minecraft/server';
import { score, set } from 'score.js';
import { triggerEvent } from 'main.js';
import { attack, projectile, getEntites, breakBlock } from 'base/attack.js';

//-----------------------------------------------------
//事件
//________________________________________________________________
export function hw(player) {

    player.runCommand(`tp @e[name="§b${player.nameTag} 公路之星",rm=40,r=100] @s`)
    if (player.hasTag("detect_attack") && score(player, "stand_summon") == 1 && !player.hasTag("be_stopped_of_time")) {

        switch (player.selectedSlotIndex) {
            case 0:
                if (score(player, "stand_skill_cd_4") == 0 && score(player, "stand_energy") == 100) {
                    player.runCommand("scoreboard players set @s stand_skill_cd_4 600")
                    player.runCommand("scoreboard players set @s stand_energy 0")
                    player.runCommand(`summon stand:footprints ^-1^^ ~ ~ ? "§b${player.name} 公路之星"`)
                    if (score(player, "stand_level") == 100) {
                        player.runCommand(`summon stand:footprints ^1^^ ~ ~ ? "§b${player.name} 公路之星"`)
                        player.runCommand("particle stand:hw_summon ^1^0.5^")
                    }
                    player.runCommand("particle stand:hw_summon ^-1^0.5^")
                    player.runCommand("playsound hw @a ~~~ 100 1 0")
                    const entities = player.dimension.getEntities({
                        name: `§b${player.nameTag} 公路之星`,
                        type: "stand:footprints"
                    });
                    for (const footprints of entities) {
                        footprints.getComponent("minecraft:tameable").tame(player)
                    }
                }
                break
        }
    }

}


//-----------------------------------------------------
//函数
//________________________________________________________________


//取随机整数
function randomNum(minNum, maxNum) {
    switch (arguments.length) {
        case 1:
            return parseInt(Math.random() * minNum + 1, 10);
            break;
        case 2:
            return parseInt(Math.random() * (maxNum - minNum + 1) + minNum, 10);
            break;
        default:
            return 0;
            break;
    }
};

export function hwNoSkill(player) {
    function score(player, objective) {
        try {
            return world.scoreboard.getObjective(objective)
                .getScore(player.scoreboardIdentity)
        } catch (e) {
            return 0;
        }
    }
    if (score(player, "stand_skill_cd_4") == 0) {
        return true;
    } else {
        return false;
    }
}