//-----------------------------------------------------
//导入
//________________________________________________________________

import { ItemStack,  world, system } from '@minecraft/server';
import { ActionFormData, ModalFormData } from '@minecraft/server-ui';
import { score, set } from 'score.js';
import { attack, projectile, getEntites, breakBlock } from 'base/attack.js';

//-----------------------------------------------------
//事件
//________________________________________________________________

world.afterEvents.itemUse.subscribe(event => {
    const item = event.itemStack;
    const player = event.source;
    if (item.typeId == "stand:th" && !player.hasTag("be_stopped_of_time")) {
        try {
            attacks(player)
        } catch(error) {}
        player.runCommand("playsound th @s ~~~ 300 1 0")
        system.runTimeout(() => {
            player.runCommand("clear @s stand:th 0 1")
            player.runCommand("playsound random.break @a ~~~ 100 1 0")
        }, 20)
        system.runTimeout(() => {
            try {
                attacks(player)
            } catch(error) {}
        }, 5)
        system.runTimeout(() => {
            try {
                attacks(player)
            } catch(error) {}
        }, 10)
        system.runTimeout(() => {
            try {
                attacks(player)
            } catch(error) {}
        }, 15)
    }
});

//-----------------------------------------------------
//函数
//________________________________________________________________

function attacks(player) {
    let entities = getEntites(player, 2.5)
    try {
        entities[0].entity.remove()
    } catch(error) {}
    if (!entities[0].entity)return;
    entities[0].entity.runCommand("kill")
}