//-----------------------------------------------------
//导入
//________________________________________________________________

import { world, system } from '@minecraft/server'; 
import { score } from 'score.js';
import { combo } from 'combo/combo.js';

//-----------------------------------------------------
//函数
//________________________________________________________________

//谁知道ui其实是用title显示的呢？
export function repeat(player) {
    let cd4;
    let lock;
    switch (score(player, "stand_type_id")) {
        case 0:
            cd4 = `${score(player, "stand_skill_cd_4") > 0 ? 1 : 0}`
            lock = 1
            break;
        case 1:
            if (score(player, "stand_skill_cd_4") == 0) {
                if (player.isSneaking) {
                    if (score(player, "stand_level") >= 20 && !player.hasTag("time_stopper")) {
                        cd4 = 0
                    } else {
                        cd4 = 1
                    }
                } else {
                    if (score(player, "stand_level") >= 20 && score(player, "stand_energy") == 100) {
                        cd4 = 0
                    } else {
                        cd4 = 1
                    }
                }
            } else {
                cd4 = 1
            };

            if (score(player, "stand_level") >= 20) {
                lock = 0
            } else {
                lock = 1
            };
            break;
        case 2:
            cd4 = `${(score(player, "stand_level") == 100 && score(player, "stand_energy") == 100) ? (score(player, "stand_skill_cd_4") > 0 ? 1 : 0) : 1}`
            lock = `${score(player, "stand_level") == 100 ? 0 : 1}`
            break;
        case 3:
            if (score(player, "stand_level") >= 40) {
                lock = 0
            } else {
                lock = 1
            };
            if (score(player, "stand_skill_cd_4") == 0 && score(player, "stand_level") >= 40) {
                cd4 = 0
            } else {
                cd4 = 1
            }
            break;
        case 4:
            if (score(player, "angry") == 100) {
                lock = 0
            } else {
                lock = 1
            };
            if (score(player, "stand_skill_cd_4") == 0) {
                cd4 = 0
            } else {
                cd4 = 1
            }
            break;
        case 6:
            if (score(player, "stand_skill_cd_4") == 0 && score(player, "stand_energy") > 20) {
                cd4 = 0
            } else {
                cd4 = 1
            }
            break;
        case 7:
            lock = 0
            if (score(player, "stand_energy") >= 100) {
                cd4 = 0
            } else {
                cd4 = 1
            };
            break;
        case 8:
            lock = 0
            if (score(player, "stand_energy") >= 25) {
                cd4 = 0
            } else {
                cd4 = 1
            };
            break;
        case 9:
            if (score(player, "stand_skill_cd_4") == 0) {
                if (player.isSneaking) {
                    if (score(player, "stand_level") >= 20 && !player.hasTag("time_stopper")) {
                        cd4 = 0
                    } else {
                        cd4 = 1
                    }
                } else {
                    if (score(player, "stand_level") >= 20 && score(player, "stand_energy") == 100) {
                        cd4 = 0
                    } else {
                        cd4 = 1
                    }
                }
            } else {
                cd4 = 1
            };

            if (score(player, "stand_level") >= 20) {
                lock = 0
            } else {
                lock = 1
            };
            break;

    };
    if (score(player, "stand_type_id") != 5 && score(player, "stand_summon") == 0) {
        cd4 = 1
    }
    
    const newLine = "\n\n\n\n\n\n\n\n\n\n";
    let subtitle = `                                                               ${score(player, "stand_skill_cd_1") > 0 ? "§7":"§f"}${(score(player, "stand_skill_cd_1")/20).toFixed(1)}  ${score(player, "stand_skill_cd_2") > 0 ? "§7":"§f"}${(score(player, "stand_skill_cd_2")/20).toFixed(1)}  ${score(player, "stand_skill_cd_3") > 0 ? "§7":"§f"}${(score(player, "stand_skill_cd_3")/20).toFixed(1)}  ${score(player, "stand_skill_cd_4") > 0 ? "§7":"§f"}${(score(player, "stand_skill_cd_4")/20).toFixed(1)}`;
    if (score(player, "stand_type_id") == 5) {
        subtitle = `                                                               ${score(player, "stand_skill_cd_1") > 0 ? "§7":"§f"}${(score(player, "stand_skill_cd_1")/20).toFixed(1)}`;
    }
    if (score(player, "stand_type_id") == 7) {
        subtitle = `                                                                     ${score(player, "stand_skill_cd_4") > 0 ? "§7":"§f"}${(score(player, "stand_skill_cd_4")/20).toFixed(1)}`;
    }
    if (score(player, "stand_type_id") == 8) {
        subtitle = `                                                                     ${score(player, "stand_skill_cd_4") > 0 ? "§7":"§f"}${(score(player, "stand_skill_cd_4")/20).toFixed(1)}`;
    }
    
    subtitle = `§c${parseInt(player.getComponent("health").currentValue)}/${parseInt(player.getComponent("health").effectiveMax)}§r                                                                               \n${subtitle}`
    // subtitle =`${player.getComponent("minecraft:movement").currentValue}/${player.getComponent("minecraft:movement").effectiveMax}\n${subtitle}`
    
    let title = "";

    if (combo[player.name] != undefined && combo[player.name] > 0 && player.hasTag("combo_title")) {
        title = `${title}        Combo${combo[player.name] > 19 ? "§e" : combo[player.name] > 9 ? "§g" : combo[player.name] > 4 ? "§b" : ""} ${combo[player.name]}§r`
    }
    if (player.hasTag("defend:true")) {
        title = `${title}    §aBlock!§r`
    }
    if (player.hasTag("miss")) {
        title = `${title}    Miss§r`
    }
    
    title = `
            ${newLine}
            ${title}
            ${newLine}
            ${newLine}
            [H:${parseInt((player.getComponent("health").currentValue/player.getComponent("health").effectiveMax)*100)}]
            [Lock:${lock}]
            [StandA:${score(player, "stand_type_id") == 4 ? 1 : 0}]
            [SA:${score(player, "angry")}]
            [Cd1:${score(player, "stand_skill_cd_1") > 0 || score(player, "stand_summon") == 0 ? (score(player, "stand_type_id") == 5 || score(player, "stand_type_id") == 7 || score(player, "stand_type_id") == 8 ? 0 : 1) : 0}]
            [Cd2:${score(player, "stand_skill_cd_2") > 0 || score(player, "stand_summon") == 0 ? (score(player, "stand_type_id") == 5 || score(player, "stand_type_id") == 7 || score(player, "stand_type_id") == 8 ? 0 : 1) : 0}]
            [Cd3:${score(player, "stand_skill_cd_3") > 0 || score(player, "stand_summon") == 0 ? (score(player, "stand_type_id") == 5 || score(player, "stand_type_id") == 7 || score(player, "stand_type_id") == 8 || ( score(player, "stand_type_id") == 6 && score(player, "stand_energy") > 5 && score(player, "stand_summon") == 1) ? 0 : 1) : 0}]
            [Cd4:${cd4}]
            [selectedSlot:${(score(player, "stand_type_id")==5?5:((score(player, "stand_type_id") == 7 || score(player, "stand_type_id") == 8) ?(score(player, "selectedSlot") == 0 ? 3 : 5):score(player, "selectedSlot")))}]
            [crosshair:${score(player, "crosshair")}]
            [StandTimeStop:${player.hasTag("be_stopped_of_time") || player.hasTag("anbs_player")?1:0}]
            [StandE:1]
            [StandL:1]
            [StandTypeId:${score(player, "stand_type_id")}]
            [StandEnergy:${parseInt(score(player, "stand_energy") / 100 * 100)}]
            [StandLevel:${parseInt(score(player, "stand_level") / 100 * 100)}]
           `;
    subtitle = `
               ${newLine}
               \n\n\n\n\n
               ${subtitle}
              `;
    player.onScreenDisplay.updateSubtitle(subtitle);
    player.onScreenDisplay.setTitle(title);
}